---
title: Dynamic Default Question Values
product: Form Library
description: Learn how to preconfigure question values using values of other questions, date and math functions, or custom functions defined in your JavaScript code. View a free demo for JavaScript to learn more.
framework: Vanilla JS
source: https://surveyjs.io/form-library/examples/specify-default-question-value-dynamically/vanillajs
index: https://surveyjs.io/form-library/examples/overview.md
---

# Dynamic Default Question Values (Vanilla JS)

SurveyJS Form Library allows you to specify default question values. Questions use them until proper values are specified by a user or programmatically. If the proper values are never specified, default values are saved in survey results.

You can specify static default values or calculate default values dynamically. To specify a static default question value, assign it to the question's [`defaultValue`](https://surveyjs.io/form-library/documentation/api-reference/question#defaultValue) property.

To calculate a default question value dynamically, assign a logical expression to the question's [`defaultValueExpression`](https://surveyjs.io/form-library/documentation/api-reference/question#defaultValueExpression) property as shown in this demo. This expression will be evaluated for the first time when the survey begins, and then re-evaluated again each time any question value changes. Your expression can include the following dynamic elements:

- [Question values](https://surveyjs.io/form-library/documentation/design-survey/conditional-logic#question-values)
- [Variables](https://surveyjs.io/form-library/documentation/design-survey/conditional-logic#variables)
- [Calculated values](https://surveyjs.io/form-library/documentation/design-survey/conditional-logic#calculated-values)
- [Built-in functions](https://surveyjs.io/form-library/documentation/design-survey/conditional-logic#built-in-functions)
- [Custom JavaScript functions](https://surveyjs.io/form-library/documentation/design-survey/conditional-logic#custom-functions)

Follow the links above for information on how to use these elements to specify dynamic default question values.

## Files

### `public/index.html`

```html
<div id="surveyElement" style="position: absolute; top: 0; left: 0; right: 0; bottom: 0; min-height: 100%; height:100%"></div>
```

### `src/index.css`

```css
/* You can add your custom CSS here. */
```

### `src/index.js`

```js
import { Model } from "survey-core";
import "survey-js-ui";
import "survey-core/survey-core.min.css";
import "./index.css";
import { json } from "./json";
import { registerFunction } from "survey-core";

// Register a custom expression function
function calculateCircleArea(params) {
    let radius = params[0];
    let area = Math.PI * Math.pow(radius, 2);
    return area;
}
registerFunction({ name: "calculateCircleArea", func: calculateCircleArea });
const survey = new Model(json);
survey.onComplete.add((sender, options) => {
    console.log(JSON.stringify(sender.data, null, 3));
});
survey.setVariable('userName', 'Jane Doe');


survey.render(document.getElementById("surveyElement"));
```

### `src/json.js`

```js
export const json = {
  "pages": [
    {
      "name": "page1",
      "elements": [
        {
          "type": "text",
          "title": "Survey Variables in Expressions",
          "description": "Concatenate a string literal with a survey variable to define a default value.",
          "name": "user-name",
          "defaultValueExpression": "'Hello, ' + {userName}"
        },
        {
          "type": "panel",
          "name": "car-info",
          "elements": [
            {
              "type": "dropdown",
              "name": "car-brand",
              "title": "Which is the brand of your car?",
              "choices": [
                "Ford",
                "Vauxhall",
                "Volkswagen",
                "Nissan",
                "Audi",
                "Mercedes-Benz",
                "BMW",
                "Peugeot",
                "Toyota",
                "Citroen"
              ],
              "defaultValue": "Audi",
              "showOtherItem": true,
              "showNoneItem": true
            },
            {
              "type": "text",
              "name": "your-car",
              "startWithNewLine": false,
              "title": "Your Car",
              "defaultValueExpression": "{car-brand}"
            }
          ],
          "title": "Question Values in Expressions",
          "description": "Use a value from a drop-down menu as a default value for a text box."
        },
        {
          "type": "paneldynamic",
          "name": "vacation-info",
          "title": "Default Value Expressions in Dynamic Panels",
          "panelCount": 1,
          "description": "Use `{panel.questionName}` to reference a nested question's value in expressions.",
          "templateElements": [
            {
              "type": "dropdown",
              "name": "country",
              "title": "Select a country",
              "defaultValue": "Cyprus",
              "choicesByUrl": {
                "url": "https://surveyjs.io/api/CountriesExample",
                "valueName": "name"
              }
            },
            {
              "type": "text",
              "name": "start-date",
              "title": "Select a vacation start date",
              "description": "Use the `today()` function to specify the current date.",
              "defaultValueExpression": "today()",
              "inputType": "date"
            },
            {
              "type": "text",
              "name": "end-date",
              "startWithNewLine": false,
              "title": "Select a vacation end date",
              "description": "Use the `today(daysToAdd)` function to shift the current date to a specified number of days.",
              "defaultValueExpression": "today(10)",
              "validators": [
                {
                  "type": "expression",
                  "text": "End date should be greater than start date",
                  "expression": "{panel.end-date} empty or {panel.end-date} > {panel.start-date}"
                }
              ],
              "inputType": "date"
            },
            {
              "type": "text",
              "name": "days-spent",
              "title": "Days spent in {panel.country}",
              "titleLocation": "left",
              "defaultValueExpression": "iif({panel.start-date} < {panel.end-date}, diffDays({panel.start-date}, {panel.end-date}))"
            }
          ]
        },
        {
          "type": "matrixdropdown",
          "name": "company-role",
          "title": "Default Value Expressions in Matrix Cells",
          "description": "Use `{row.questionName}` to reference a question from the same row in expressions. In this matrix, select \"No\" in the first column, and the second column row cell will also be set to \"No\".",
          "columns": [
            {
              "name": "employee-role-availability",
              "title": "Do you have the following employee role in your company?"
            },
            {
              "name": "isStaffed",
              "title": "Is this position currently filled?",
              "defaultValueExpression": "iif({row.employee-role-availability} = 'No', 'No', '')"
            }
          ],
          "choices": [
            "Yes",
            "No"
          ],
          "rows": [
            "Sales Representative",
            "Software Developer",
            "Human Resources Manager"
          ]
        },
        {
          "type": "panel",
          "name": "math-calculations",
          "elements": [
            {
              "type": "text",
              "name": "radius",
              "title": "Enter circle radius",
              "defaultValue": 3,
              "inputType": "numeric",
              "min": 0,
              "max": 10
            },
            {
              "type": "text",
              "title": "Area of the circle",
              "name": "circle-area",
              "defaultValueExpression": "calculateCircleArea({radius})",
              "startWithNewLine": false
            }
          ],
          "title": "Custom JavaScript Function",
          "description": "Register a custom JavaScript function to perform custom calculations."
        }
      ]
    }
  ],
  "questionErrorLocation": "bottom"
};
```

### `src/theme.js`

```js
export const themeJson = {};
```

### `package.json`

```json
{
  "dependencies": {
    "survey-core": "latest",
    "survey-js-ui": "latest"
  }
}
```

## Other Frameworks

- [Angular](https://surveyjs.io/form-library/examples/specify-default-question-value-dynamically/angular.md)
- [React](https://surveyjs.io/form-library/examples/specify-default-question-value-dynamically/reactjs.md)
- [Vue 3](https://surveyjs.io/form-library/examples/specify-default-question-value-dynamically/vue3js.md)
- [jQuery](https://surveyjs.io/form-library/examples/specify-default-question-value-dynamically/jquery.md)


---
title: Dynamic Default Question Values
product: Form Library
description: Learn how to preconfigure question values using values of other questions, date and math functions, or custom functions defined in your JavaScript code. View a free demo for JavaScript to learn more.
framework: Angular
source: https://surveyjs.io/form-library/examples/specify-default-question-value-dynamically/angular
index: https://surveyjs.io/form-library/examples/overview.md
---

# Dynamic Default Question Values (Angular)

SurveyJS Form Library allows you to specify default question values. Questions use them until proper values are specified by a user or programmatically. If the proper values are never specified, default values are saved in survey results.

You can specify static default values or calculate default values dynamically. To specify a static default question value, assign it to the question's [`defaultValue`](https://surveyjs.io/form-library/documentation/api-reference/question#defaultValue) property.

To calculate a default question value dynamically, assign a logical expression to the question's [`defaultValueExpression`](https://surveyjs.io/form-library/documentation/api-reference/question#defaultValueExpression) property as shown in this demo. This expression will be evaluated for the first time when the survey begins, and then re-evaluated again each time any question value changes. Your expression can include the following dynamic elements:

- [Question values](https://surveyjs.io/form-library/documentation/design-survey/conditional-logic#question-values)
- [Variables](https://surveyjs.io/form-library/documentation/design-survey/conditional-logic#variables)
- [Calculated values](https://surveyjs.io/form-library/documentation/design-survey/conditional-logic#calculated-values)
- [Built-in functions](https://surveyjs.io/form-library/documentation/design-survey/conditional-logic#built-in-functions)
- [Custom JavaScript functions](https://surveyjs.io/form-library/documentation/design-survey/conditional-logic#custom-functions)

Follow the links above for information on how to use these elements to specify dynamic default question values.

## Files

### `src/app/components/json.ts`

```ts
export const json = {
  "pages": [
    {
      "name": "page1",
      "elements": [
        {
          "type": "text",
          "title": "Survey Variables in Expressions",
          "description": "Concatenate a string literal with a survey variable to define a default value.",
          "name": "user-name",
          "defaultValueExpression": "'Hello, ' + {userName}"
        },
        {
          "type": "panel",
          "name": "car-info",
          "elements": [
            {
              "type": "dropdown",
              "name": "car-brand",
              "title": "Which is the brand of your car?",
              "choices": [
                "Ford",
                "Vauxhall",
                "Volkswagen",
                "Nissan",
                "Audi",
                "Mercedes-Benz",
                "BMW",
                "Peugeot",
                "Toyota",
                "Citroen"
              ],
              "defaultValue": "Audi",
              "showOtherItem": true,
              "showNoneItem": true
            },
            {
              "type": "text",
              "name": "your-car",
              "startWithNewLine": false,
              "title": "Your Car",
              "defaultValueExpression": "{car-brand}"
            }
          ],
          "title": "Question Values in Expressions",
          "description": "Use a value from a drop-down menu as a default value for a text box."
        },
        {
          "type": "paneldynamic",
          "name": "vacation-info",
          "title": "Default Value Expressions in Dynamic Panels",
          "panelCount": 1,
          "description": "Use `{panel.questionName}` to reference a nested question's value in expressions.",
          "templateElements": [
            {
              "type": "dropdown",
              "name": "country",
              "title": "Select a country",
              "defaultValue": "Cyprus",
              "choicesByUrl": {
                "url": "https://surveyjs.io/api/CountriesExample",
                "valueName": "name"
              }
            },
            {
              "type": "text",
              "name": "start-date",
              "title": "Select a vacation start date",
              "description": "Use the `today()` function to specify the current date.",
              "defaultValueExpression": "today()",
              "inputType": "date"
            },
            {
              "type": "text",
              "name": "end-date",
              "startWithNewLine": false,
              "title": "Select a vacation end date",
              "description": "Use the `today(daysToAdd)` function to shift the current date to a specified number of days.",
              "defaultValueExpression": "today(10)",
              "validators": [
                {
                  "type": "expression",
                  "text": "End date should be greater than start date",
                  "expression": "{panel.end-date} empty or {panel.end-date} > {panel.start-date}"
                }
              ],
              "inputType": "date"
            },
            {
              "type": "text",
              "name": "days-spent",
              "title": "Days spent in {panel.country}",
              "titleLocation": "left",
              "defaultValueExpression": "iif({panel.start-date} < {panel.end-date}, diffDays({panel.start-date}, {panel.end-date}))"
            }
          ]
        },
        {
          "type": "matrixdropdown",
          "name": "company-role",
          "title": "Default Value Expressions in Matrix Cells",
          "description": "Use `{row.questionName}` to reference a question from the same row in expressions. In this matrix, select \"No\" in the first column, and the second column row cell will also be set to \"No\".",
          "columns": [
            {
              "name": "employee-role-availability",
              "title": "Do you have the following employee role in your company?"
            },
            {
              "name": "isStaffed",
              "title": "Is this position currently filled?",
              "defaultValueExpression": "iif({row.employee-role-availability} = 'No', 'No', '')"
            }
          ],
          "choices": [
            "Yes",
            "No"
          ],
          "rows": [
            "Sales Representative",
            "Software Developer",
            "Human Resources Manager"
          ]
        },
        {
          "type": "panel",
          "name": "math-calculations",
          "elements": [
            {
              "type": "text",
              "name": "radius",
              "title": "Enter circle radius",
              "defaultValue": 3,
              "inputType": "numeric",
              "min": 0,
              "max": 10
            },
            {
              "type": "text",
              "title": "Area of the circle",
              "name": "circle-area",
              "defaultValueExpression": "calculateCircleArea({radius})",
              "startWithNewLine": false
            }
          ],
          "title": "Custom JavaScript Function",
          "description": "Register a custom JavaScript function to perform custom calculations."
        }
      ]
    }
  ],
  "questionErrorLocation": "bottom"
};
```

### `src/app/components/survey.component.css`

```css
/* You can add your custom CSS here. */
```

### `src/app/components/survey.component.html`

```html
<survey [model]="model" style="position: absolute; top: 0; left: 0; right: 0; bottom: 0; height:100%"></survey>
```

### `src/app/components/survey.component.ts`

```ts
import { Component, OnInit } from "@angular/core";
import { Model } from "survey-core";
import { json } from "./json";
import "./survey.component.css";
import "survey-core/survey-core.min.css";
import { registerFunction } from "survey-core";

// Register a custom expression function
function calculateCircleArea(params) {
    let radius = params[0];
    let area = Math.PI * Math.pow(radius, 2);
    return area;
}
registerFunction({ name: "calculateCircleArea", func: calculateCircleArea });
@Component({
    // tslint:disable-next-line:component-selector
    selector: "component-survey",
    templateUrl: "./survey.component.html",
    styleUrls: ["./survey.component.css"]
})
export class SurveyComponent implements OnInit {
    model: Model;
    ngOnInit() {
        const survey = new Model(json);
        survey.setVariable('userName', 'Jane Doe');
        
        survey.onComplete.add((sender, options) => {
            console.log(JSON.stringify(sender.data, null, 3));
        });
        this.model = survey;
    }
}
```

### `src/app/components/theme.ts`

```ts
export const themeJson = {};
```

### `src/app/app.component.css`

```css

```

### `src/app/app.component.html`

```html
<component-survey></component-survey>
```

### `src/app/app.component.ts`

```ts
import { Component } from "@angular/core";

@Component({
    selector: "app-root",
    templateUrl: "./app.component.html",
    styleUrls: ["./app.component.css"]
})
export class AppComponent {
    title = "CodeSandbox";
}
```

### `src/app/app.module.ts`

```ts
import { BrowserModule } from "@angular/platform-browser";
import { NgModule } from "@angular/core";

import { AppComponent } from "./app.component";
import { SurveyModule } from "survey-angular-ui";
import { SurveyComponent } from "./components/survey.component";

@NgModule({
    declarations: [AppComponent, SurveyComponent],
    imports: [BrowserModule, SurveyModule],
    providers: [],
    bootstrap: [AppComponent]
})
export class AppModule { }
```

### `src/environments/environment.prod.ts`

```ts
export const environment = {
    production: true
};
```

### `src/environments/environment.ts`

```ts
// The file contents for the current environment will overwrite these during build.
// The build system defaults to the dev environment which uses `environment.ts`, but if you do
// `ng build --env=prod` then `environment.prod.ts` will be used instead.
// The list of which env maps to which file can be found in `.angular-cli.json`.

export const environment = {
    production: false
};
```

### `src/index.html`

```html
<app-root></app-root>
```

### `src/main.ts`

```ts
import { enableProdMode } from "@angular/core";
import { platformBrowserDynamic } from "@angular/platform-browser-dynamic";

import { AppModule } from "./app/app.module";
import { environment } from "./environments/environment";

if (environment.production) {
    enableProdMode();
}

platformBrowserDynamic()
    .bootstrapModule(AppModule)
    .catch(err => console.log(err));
```

### `src/polyfills.ts`

```ts
/**
 * This file includes polyfills needed by Angular and is loaded before the app.
 * You can add your own extra polyfills to this file.
 *
 * This file is divided into 2 sections:
 *   1. Browser polyfills. These are applied before loading ZoneJS and are sorted by browsers.
 *   2. Application imports. Files imported after ZoneJS that should be loaded before your main
 *      file.
 *
 * The current setup is for so-called "evergreen" browsers; the last versions of browsers that
 * automatically update themselves. This includes Safari >= 10, Chrome >= 55 (including Opera),
 * Edge >= 13 on the desktop, and iOS 10 and Chrome on mobile.
 *
 * Learn more in https://angular.io/docs/ts/latest/guide/browser-support.html
 */

/***************************************************************************************************
 * BROWSER POLYFILLS
 */

/** IE9, IE10 and IE11 requires all of the following polyfills. **/
// import 'core-js/es6/symbol';
// import 'core-js/es6/object';
// import 'core-js/es6/function';
// import 'core-js/es6/parse-int';
// import 'core-js/es6/parse-float';
// import 'core-js/es6/number';
// import 'core-js/es6/math';
// import 'core-js/es6/string';
// import 'core-js/es6/date';
// import 'core-js/es6/array';
// import 'core-js/es6/regexp';
// import 'core-js/es6/map';
// import 'core-js/es6/weak-map';
// import 'core-js/es6/set';

/** IE10 and IE11 requires the following for NgClass support on SVG elements */
// import 'classlist.js';  // Run `npm install classlist.js`.

/** IE10 and IE11 requires the following for the Reflect API. */
// import 'core-js/es6/reflect';

/** Evergreen browsers require these. **/
// Used for reflect-metadata in JIT. If you use AOT (and only Angular decorators), you can remove.
import "core-js/proposals/reflect-metadata";

/**
 * Required to support Web Animations `@angular/platform-browser/animations`.
 * Needed for: All but Chrome, Firefox and Opera. http://caniuse.com/#feat=web-animation
 **/
// import 'web-animations-js';  // Run `npm install web-animations-js`.

/***************************************************************************************************
 * Zone JS is required by default for Angular itself.
 */
import "zone.js/dist/zone"; // Included with Angular CLI.

/***************************************************************************************************
 * APPLICATION IMPORTS
 */
```

### `src/styles.css`

```css
/* You can add your custom CSS here. */
```

### `src/typings.d.ts`

```ts
/* SystemJS module definition */
declare var module: NodeModule;
interface NodeModule {
    id: string;
}
```

### `.angular-cli.json`

```json
{
  "apps": [
    {
      "root": "src",
      "outDir": "dist",
      "assets": [ "assets", "favicon.ico" ],
      "index": "index.html",
      "main": "main.ts",
      "polyfills": "polyfills.ts",
      "prefix": "app",
      "styles": [ "styles.css" ],
      "scripts": [ ],
      "environmentSource": "environments/environment.ts",
      "environments": {
        "dev": "environments/environment.ts",
        "prod": "environments/environment.prod.ts"
      }
    }
  ]
}
```

### `_tsconfig.json`

```json
{
  "compileOnSave": false,
  "compilerOptions": {
    "baseUrl": "./",
    "outDir": "./dist/out-tsc",
    "sourceMap": true,
    "declaration": false,
    "allowSyntheticDefaultImports": true,
    "downlevelIteration": true,
    "experimentalDecorators": true,
    "moduleResolution": "node",
    "importHelpers": true,
    "resolveJsonModule": true,
    "target": "es2015",
    "module": "es2020",
    "lib": [
      "es2018",
      "dom"
    ]
  }
}
```

### `package.json`

```json
{
  "name": "surveyjs-angular",
  "scripts": {
    "ng": "ng",
    "start": "ng serve",
    "build": "ng build --prod",
    "test": "ng test",
    "lint": "ng lint",
    "e2e": "ng e2e"
  },
  "private": true,
  "dependencies": {
    "@angular/animations": "14.1.1",
    "@angular/cdk": "14.1.1",
    "@angular/common": "14.1.1",
    "@angular/compiler": "14.1.1",
    "@angular/core": "14.1.1",
    "@angular/forms": "14.1.1",
    "@angular/platform-browser": "14.1.1",
    "@angular/platform-browser-dynamic": "14.1.1",
    "@angular/router": "14.1.1",
    "core-js": "3.6.4",
    "rxjs": "6.5.4",
    "survey-core": "latest",
    "survey-angular-ui": "latest",
    "tslib": "1.13.0",
    "zone.js": "0.11.7"
  },
  "devDependencies": {
    "@angular/cli": "1.6.6",
    "@angular/compiler-cli": "^5.2.0",
    "@angular/language-service": "^5.2.0",
    "@types/core-js": "0.9.46",
    "@types/jasmine": "~2.8.3",
    "@types/jasminewd2": "~2.0.2",
    "@types/node": "~6.0.60",
    "codelyzer": "^4.0.1",
    "jasmine-core": "~2.8.0",
    "jasmine-spec-reporter": "~4.2.1",
    "karma": "~2.0.0",
    "karma-chrome-launcher": "~2.2.0",
    "karma-coverage-istanbul-reporter": "^1.2.1",
    "karma-jasmine": "~1.1.0",
    "karma-jasmine-html-reporter": "^0.2.2",
    "protractor": "~5.1.2",
    "ts-node": "~4.1.0",
    "tslint": "~5.9.1",
    "typescript": "3.9.7"
  },
  "keywords": [ "angular", "surveyjs" ],
  "description": "SurveyJS-Angular example project"
}
```

## Other Frameworks

- [React](https://surveyjs.io/form-library/examples/specify-default-question-value-dynamically/reactjs.md)
- [Vue 3](https://surveyjs.io/form-library/examples/specify-default-question-value-dynamically/vue3js.md)
- [jQuery](https://surveyjs.io/form-library/examples/specify-default-question-value-dynamically/jquery.md)
- [Vanilla JS](https://surveyjs.io/form-library/examples/specify-default-question-value-dynamically/vanillajs.md)


---
title: Dynamic Default Question Values
product: Form Library
description: Learn how to preconfigure question values using values of other questions, date and math functions, or custom functions defined in your JavaScript code. View a free demo for JavaScript to learn more.
framework: React
source: https://surveyjs.io/form-library/examples/specify-default-question-value-dynamically/reactjs
index: https://surveyjs.io/form-library/examples/overview.md
---

# Dynamic Default Question Values (React)

SurveyJS Form Library allows you to specify default question values. Questions use them until proper values are specified by a user or programmatically. If the proper values are never specified, default values are saved in survey results.

You can specify static default values or calculate default values dynamically. To specify a static default question value, assign it to the question's [`defaultValue`](https://surveyjs.io/form-library/documentation/api-reference/question#defaultValue) property.

To calculate a default question value dynamically, assign a logical expression to the question's [`defaultValueExpression`](https://surveyjs.io/form-library/documentation/api-reference/question#defaultValueExpression) property as shown in this demo. This expression will be evaluated for the first time when the survey begins, and then re-evaluated again each time any question value changes. Your expression can include the following dynamic elements:

- [Question values](https://surveyjs.io/form-library/documentation/design-survey/conditional-logic#question-values)
- [Variables](https://surveyjs.io/form-library/documentation/design-survey/conditional-logic#variables)
- [Calculated values](https://surveyjs.io/form-library/documentation/design-survey/conditional-logic#calculated-values)
- [Built-in functions](https://surveyjs.io/form-library/documentation/design-survey/conditional-logic#built-in-functions)
- [Custom JavaScript functions](https://surveyjs.io/form-library/documentation/design-survey/conditional-logic#custom-functions)

Follow the links above for information on how to use these elements to specify dynamic default question values.

## Files

### `public/index.html`

```html
<div id="surveyElement" style="position: absolute; top: 0; left: 0; right: 0; bottom: 0; min-height: 100%; height:100%"></div>
```

### `src/SurveyComponent.jsx`

```js
import React from "react";
import { Model } from "survey-core";
import { Survey } from "survey-react-ui";
import "survey-core/survey-core.min.css";
import "./index.css";
import { json } from "./json";
import { registerFunction } from "survey-core";

// Register a custom expression function
function calculateCircleArea(params) {
    let radius = params[0];
    let area = Math.PI * Math.pow(radius, 2);
    return area;
}
registerFunction({ name: "calculateCircleArea", func: calculateCircleArea });
function SurveyComponent() {
    const survey = new Model(json);
    survey.onComplete.add((sender, options) => {
        console.log(JSON.stringify(sender.data, null, 3));
    });
    survey.setVariable('userName', 'Jane Doe');
    
    return (<Survey model={survey} />);
}

export default SurveyComponent;
```

### `src/index.css`

```css
/* You can add your custom CSS here. */
```

### `src/index.js`

```js
import React from "react";
import { createRoot } from "react-dom/client";
import SurveyComponent from "./SurveyComponent";

const root = createRoot(document.getElementById("surveyElement"));
root.render(<SurveyComponent />);
```

### `src/json.js`

```js
export const json = {
  "pages": [
    {
      "name": "page1",
      "elements": [
        {
          "type": "text",
          "title": "Survey Variables in Expressions",
          "description": "Concatenate a string literal with a survey variable to define a default value.",
          "name": "user-name",
          "defaultValueExpression": "'Hello, ' + {userName}"
        },
        {
          "type": "panel",
          "name": "car-info",
          "elements": [
            {
              "type": "dropdown",
              "name": "car-brand",
              "title": "Which is the brand of your car?",
              "choices": [
                "Ford",
                "Vauxhall",
                "Volkswagen",
                "Nissan",
                "Audi",
                "Mercedes-Benz",
                "BMW",
                "Peugeot",
                "Toyota",
                "Citroen"
              ],
              "defaultValue": "Audi",
              "showOtherItem": true,
              "showNoneItem": true
            },
            {
              "type": "text",
              "name": "your-car",
              "startWithNewLine": false,
              "title": "Your Car",
              "defaultValueExpression": "{car-brand}"
            }
          ],
          "title": "Question Values in Expressions",
          "description": "Use a value from a drop-down menu as a default value for a text box."
        },
        {
          "type": "paneldynamic",
          "name": "vacation-info",
          "title": "Default Value Expressions in Dynamic Panels",
          "panelCount": 1,
          "description": "Use `{panel.questionName}` to reference a nested question's value in expressions.",
          "templateElements": [
            {
              "type": "dropdown",
              "name": "country",
              "title": "Select a country",
              "defaultValue": "Cyprus",
              "choicesByUrl": {
                "url": "https://surveyjs.io/api/CountriesExample",
                "valueName": "name"
              }
            },
            {
              "type": "text",
              "name": "start-date",
              "title": "Select a vacation start date",
              "description": "Use the `today()` function to specify the current date.",
              "defaultValueExpression": "today()",
              "inputType": "date"
            },
            {
              "type": "text",
              "name": "end-date",
              "startWithNewLine": false,
              "title": "Select a vacation end date",
              "description": "Use the `today(daysToAdd)` function to shift the current date to a specified number of days.",
              "defaultValueExpression": "today(10)",
              "validators": [
                {
                  "type": "expression",
                  "text": "End date should be greater than start date",
                  "expression": "{panel.end-date} empty or {panel.end-date} > {panel.start-date}"
                }
              ],
              "inputType": "date"
            },
            {
              "type": "text",
              "name": "days-spent",
              "title": "Days spent in {panel.country}",
              "titleLocation": "left",
              "defaultValueExpression": "iif({panel.start-date} < {panel.end-date}, diffDays({panel.start-date}, {panel.end-date}))"
            }
          ]
        },
        {
          "type": "matrixdropdown",
          "name": "company-role",
          "title": "Default Value Expressions in Matrix Cells",
          "description": "Use `{row.questionName}` to reference a question from the same row in expressions. In this matrix, select \"No\" in the first column, and the second column row cell will also be set to \"No\".",
          "columns": [
            {
              "name": "employee-role-availability",
              "title": "Do you have the following employee role in your company?"
            },
            {
              "name": "isStaffed",
              "title": "Is this position currently filled?",
              "defaultValueExpression": "iif({row.employee-role-availability} = 'No', 'No', '')"
            }
          ],
          "choices": [
            "Yes",
            "No"
          ],
          "rows": [
            "Sales Representative",
            "Software Developer",
            "Human Resources Manager"
          ]
        },
        {
          "type": "panel",
          "name": "math-calculations",
          "elements": [
            {
              "type": "text",
              "name": "radius",
              "title": "Enter circle radius",
              "defaultValue": 3,
              "inputType": "numeric",
              "min": 0,
              "max": 10
            },
            {
              "type": "text",
              "title": "Area of the circle",
              "name": "circle-area",
              "defaultValueExpression": "calculateCircleArea({radius})",
              "startWithNewLine": false
            }
          ],
          "title": "Custom JavaScript Function",
          "description": "Register a custom JavaScript function to perform custom calculations."
        }
      ]
    }
  ],
  "questionErrorLocation": "bottom"
};
```

### `src/theme.js`

```js
export const themeJson = {};
```

### `package.json`

```json
{
  "dependencies": {
    "react": "latest",
    "react-dom": "latest",
    "survey-core": "latest",
    "survey-react-ui": "latest"
  },
  "devDependencies": {
    "react-scripts": "latest"
  }
}
```

## Other Frameworks

- [Angular](https://surveyjs.io/form-library/examples/specify-default-question-value-dynamically/angular.md)
- [Vue 3](https://surveyjs.io/form-library/examples/specify-default-question-value-dynamically/vue3js.md)
- [jQuery](https://surveyjs.io/form-library/examples/specify-default-question-value-dynamically/jquery.md)
- [Vanilla JS](https://surveyjs.io/form-library/examples/specify-default-question-value-dynamically/vanillajs.md)
